/*

	This program is used to create classes makefile and Project.h

	Version, Revision and Date are read  from  the  "Project.c"  file.  The
	directory  name  is  used  as class name. This informations are used to
	define the values VER, REV, DATE and NAME of  the  makefile.  The  file
	"Feelin:Sources/_template/makefile",  which  define  actions, is append
	then.

$VER: 02.00 (2005/08/10)

	The program does now create an additionnal "Project.h"  file  which  is
	used to create a header file for <feelin/class_startup.c>

*/

#include <string.h>
#include <feelin/machine.h>
#include <feelin/string.h>

#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/utility.h>
 
#include <dos/dosextens.h>

#define BUF_SIZE                                1024

#ifdef __AROS__
#define SOURCE                                  "$(FEELINTOP)/_make/makefile"
#else
#define SOURCE                                  "Feelin:_make/makefile"
#endif

#define SKIP_WHITE(cur)                         while (*cur && *cur == ' ') cur++;

struct MyData
{
   UBYTE                            Project[BUF_SIZE];
   UBYTE                            Path[BUF_SIZE];
   UBYTE                            Make[BUF_SIZE];
};

struct UtilityBase *UtilityBase;

int main(void)
{
	UtilityBase = (struct UtilityBase *) IEXEC OpenLibrary("utility.library",36);
	
	if (UtilityBase)
	{
		struct Process *proc = (struct Process *) IEXEC FindTask(NULL);
		struct MyData *data = IEXEC AllocMem(sizeof (struct MyData),MEMF_CLEAR);
		 
		if (data)
		{
			BPTR project = IDOS_ Open("Project.c",MODE_OLDFILE);
			
			if (project)
			{
				BOOL ok = FALSE;
	
				while (IDOS_ FGets(project,(STRPTR)(&data -> Project),BUF_SIZE))
				{
					if (IUTILITY Strnicmp("$VER: ",data->Project,6) == 0)
					{
						ok = TRUE; break;
					}
				}

				if (ok)
				{
					BPTR make_out = IDOS_ Open("makefile",MODE_NEWFILE);
					BPTR head_out = IDOS_ Open("Project.h",MODE_NEWFILE);
					
					IDOS_ NameFromLock(proc -> pr_CurrentDir,(STRPTR)(&data -> Path),BUF_SIZE);
						
					if (make_out && head_out)
					{
						BPTR lock;
						STRPTR cur = data->Project + 5;
						STRPTR bgn;
						LONG ver=0,rev=0,len;
						
						IDOS_ FPrintf(make_out,"#\n# This file was automatically generated by F_Make from \"Project.c\"\n#\n\n");
						IDOS_ FPrintf(head_out,"/*\n**\n**  This file was automatically generated by F_Make from \"Project.c\"\n**\n*/\n\n");

						SKIP_WHITE(cur)
						
						if (*cur >= '0' && *cur <= '9')
						{
							IDOS_ FPrintf(make_out, "NAME = %s\n", (LONG) IDOS_ FilePart((STRPTR) &data->Path));
							IDOS_ FPrintf(head_out, "#define F_CLASS_NAME                            \"%s\"\n", (LONG) IDOS_ FilePart((STRPTR) &data->Path));
							
							IDOS_ Printf("F_Make: %s", (LONG) IDOS_ FilePart((STRPTR) &data->Path));
						}
						else
						{
							bgn = cur;
						   
							while (*cur && *cur != ' ') cur++;
							   
							*cur++ = 0;
						   
							IDOS_ FPrintf(make_out, "NAME = %s\n", (LONG) bgn);
							IDOS_ FPrintf(head_out, "#define F_CLASS_NAME                            \"%s\"\n", (LONG) bgn);
							   
							IDOS_ Printf("F_Make: %s", (LONG) bgn);
						   
							SKIP_WHITE(cur);
						}
						
						len = f_stcd(cur, &ver); cur += len;
						
						IDOS_ FPrintf(make_out,"VER = %02ld\n", (LONG) ver);
						IDOS_ FPrintf(head_out,"#define F_CLASS_VERSION                         %ld\n", (LONG) ver);
						
						IDOS_ Printf(" %02ld", (LONG) ver);
								
						if (*cur == '.')
						{
							cur++;

							len = f_stcd(cur, &rev); cur += len;
								
							IDOS_ FPrintf(make_out,"REV = %02ld\n", (LONG) rev);
							IDOS_ FPrintf(head_out,"#define F_CLASS_REVISION                        %ld\n", (LONG) rev);
							
							IDOS_ Printf(".%02ld", (LONG) rev);
						}
					
						SKIP_WHITE(cur);

						if (*cur == '(')
						{
							cur++;
							
							bgn = cur;
							
							while (*cur && *cur != ')') cur++;
								
							if (*cur == ')')
							{
								*cur = 0;
								
								IDOS_ FPrintf(make_out,"DATE = %s\n", (LONG) bgn);
								IDOS_ FPrintf(head_out,"#define F_CLASS_VERSION_STRING                  \"%02ld.%02ld (%s)\"\n", (LONG) ver, (LONG) rev, (LONG) bgn);
								
								IDOS_ Printf(" (%s)", (LONG) bgn);
							}
						}
						else
						{
							IDOS_ Printf("Unable to locate version date\n");
						}
					
						IDOS_ Printf("\n");
					
						IDOS_ FPrintf(make_out,"\n");
						
						lock = IDOS_ Lock("Private.h",ACCESS_READ);
						
						if (lock)
						{
							IDOS_ FPrintf(head_out,"\n#include \"Private.h\"\n");
							
							IDOS_ UnLock(lock);
						}
						
						IDOS_ FPrintf(head_out,"\n#include <feelin/class_startup.c>\n");
						
						IDOS_ FPrintf(make_out, "include %s\n", (int32) SOURCE);

						IDOS_ Flush(make_out);
						IDOS_ Flush(head_out);
					}
					
					if (make_out)
					{
						IDOS_ Close(make_out);
					}
					else
					{
						IDOS_ Printf("Unable to create makefile\n");
					}

					if (head_out)
					{
						IDOS_ Close(head_out);
					}
					else
					{
						IDOS_ Printf("Unable to create Projet.h\n");
					}
				}
				else
				{
					IDOS_ Printf("Unable to locale version information\n");
				}

				IDOS_ Close(project);
			}
			else
			{
				IDOS_ Printf("Unable to open Project.c");
			}

			IEXEC FreeMem(data,sizeof (struct MyData));
		}

		IEXEC CloseLibrary((struct Library *) UtilityBase);
	}
 
	return 0;
}
